#!/usr/bin/php5 -q
<?php 

/************************************************
* Set consts
************************************************/
$MAX_LINE = 1024;
$DEFAULT_COUNT = 20;

$use_proxy=false;
$http_proxy="www-proxy.scss.tcd.ie:8080";

$twitter_account_f = "twitter-accounts.csv";
$twitter_account_fp = fopen($twitter_account_f, "r");

$new_twitter_account_f = "new_twitter-accounts.csv";
$new_twitter_account_fp = fopen($new_twitter_account_f, "w");

$profile_images_dir = "profile_images";
$default_image_f = "$profile_images_dir/DefaultTwitter.jpg";

$today = date("Y-m-d");
$xml_out_f = "twitter-feed-$today.xml";
$xml_out_fp = fopen($xml_out_f, 'w') or die("can't open file: $xml_out_f");

fwrite($xml_out_fp, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
fwrite($xml_out_fp, "<statuses>\n");

/************************************************
* Loop through all the twitter accounts
************************************************/
while ( !feof ( $twitter_account_fp ) ) {

    $line = fgetcsv($twitter_account_fp, $MAX_LINE);
    $account = $line[0];
    $last_id = $line[1];
    print "Line: $account,$last_id\n";

    if ( empty ($account) || empty($last_id))
        continue;

    if ( $last_id == -1 ) {
        print "Requesting twiter updates for: $account for the first time. Get $DEFAULT_COUNT posts\n";
        $ch = curl_init("http://twitter.com/statuses/user_timeline/$account.xml?count=$DEFAULT_COUNT");
    } else {
        print "Requesting twiter updates for: $account since last post: $last_id\n";
        $ch = curl_init("http://twitter.com/statuses/user_timeline/$account.xml?since_id=$last_id");
    }
    // use a temp hidden file to save the xml response in
    $curl_out_fp = fopen(".out.xml", "w") or die("can't open file: .out.xml");
    if ( $use_proxy )
        curl_setopt($ch, CURLOPT_PROXY, $http_proxy);

    curl_setopt($ch, CURLOPT_FILE, $curl_out_fp);
    curl_setopt($ch, CURLOPT_HEADER, 0);
   
    if( ! $result = curl_exec($ch)) 
    { 
        trigger_error(curl_error($ch)); 
        curl_close($ch);
        continue;
    } 
    curl_close($ch);
    fclose($curl_out_fp);

    /*****************************************************
    * Now do the xml processing
    *****************************************************/    
    $profile_image_set = false;
    $new_id_set = false;
    $count = 0;

    fwrite($xml_out_fp, "<user>\n");

    $sxml =  simplexml_load_file(".out.xml"); 
    foreach($sxml->xpath('//statuses/status') as $item) {
        
//htmlentities
/*
        $user_id = htmlentities($item->user->id);
        $user_screen_name = htmlentities($item->user->screen_name);
        $user_name = htmlentities($item->user->name);
        $id = htmlentities($item->id);
        $text = htmlentities($item->text);
        $created_at = htmlentities($item->created_at);
*/
//htmlspecialchars
        $user_id = htmlspecialchars($item->user->id);
        $user_screen_name = htmlspecialchars($item->user->screen_name);
        $user_name = htmlspecialchars($item->user->name);
        $id = htmlspecialchars($item->id);
        $text = htmlspecialchars($item->text);
        $created_at = htmlspecialchars($item->created_at);
/*
        $user_id = $item->user->id;
        $user_screen_name = $item->user->screen_name;
        $user_name = $item->user->name;
        $id = $item->id;
        $text = $item->text;
        $created_at = $item->created_at;
*/
        // set the user profile image from the id and url extension
        $user_profile_image_url = $item->user->profile_image_url;
        $image_ext = substr(strrchr($user_profile_image_url, '.'), 1);
	if(substr($image_ext, 0, 3) === "com");
            $image_ext = "jpg";

        $image_out_f = "$profile_images_dir/$user_id.$image_ext";
       
        // only set this once for each account 
        if ( ! $new_id_set ) {
            print "Setting new account status id [$account, $id]\n";    
            fwrite($new_twitter_account_fp, "$account,$id\n");
            $new_id_set = true;
        }

        // only download this image once per user & only if it exists
        if ( ! $profile_image_set && ! file_exists($image_out_f) ) {
            // only downdoad if you can write to the output file
            if ( $image_out_fp = fopen($image_out_f, "w") ) {        
                $ch = curl_init($user_profile_image_url);

                if ( $use_proxy )
                    curl_setopt($ch, CURLOPT_PROXY, $http_proxy);

                curl_setopt($ch, CURLOPT_FILE, $image_out_fp);
                curl_setopt($ch, CURLOPT_HEADER, 0);
        
                if( ! $result = curl_exec($ch)) { 
                    trigger_error(curl_error($ch)); 
                } else {
                    $profile_image_set = true;
                } 
                curl_close($ch);
                fclose($image_out_fp);
            }
        }

        fwrite($xml_out_fp, "<status>\n");
        fwrite($xml_out_fp, "<user_id>$user_id</user_id>\n");
        fwrite($xml_out_fp, "<user_screen_name>$user_screen_name</user_screen_name>\n");
        fwrite($xml_out_fp, "<user_name>$user_name</user_name>\n");
        if ( $profile_image_set ) {
            fwrite($xml_out_fp, "<user_image>$image_out_f</user_image>\n");
        } else {
            fwrite($xml_out_fp, "<user_image>$default_image_f</user_image>\n");
        }        
        fwrite($xml_out_fp, "<id>$id</id>\n");
        fwrite($xml_out_fp, "<text>$text</text>\n");
        fwrite($xml_out_fp, "<created_at>$created_at</created_at>\n");
        fwrite($xml_out_fp, "</status>\n");

        $count++;
    }
    fwrite($xml_out_fp, "</user>\n");
    print "processed $count new status updates for $account\n";
}

fwrite($xml_out_fp, "</statuses>\n");
fclose($xml_out_fp);
fclose($twitter_account_fp);
fclose($new_twitter_account_fp);

//unlink(".out.xml");
unlink($twitter_account_f);
rename($new_twitter_account_f, $twitter_account_f);
?>



